import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Objects;

public class FormMap extends JFrame {
    private int Width;
    private int Height;
    DrawingMap map = new DrawingMap(this);
    private JButton ButtonDown;
    private JButton ButtonRight;
    private JButton ButtonLeft;
    private JButton ButtonUp;
    private JButton ButtonCreate;
    private JButton ButtonCreateModif;
    public JLabel SpeedLabel;
    public JLabel WeightLabel;
    public JLabel BodyColorLabel;
    private JComboBox ComboBoxSelectorMap;
    private JPanel PictureBox;

    public FormMap(){
        super("Военный корабль");
        setContentPane(PictureBox);
        setSize(1000,700);
        Width = getWidth();
        Height = getHeight();
        ShowWindow();
        map.setBounds(0,0,Width,Height);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    private void ShowWindow(){
        ButtonCreate.addActionListener(e -> {
            map.CreateButtonAction();
            ReDraw();
        });
        ButtonCreateModif.addActionListener(e -> {
            map.CreateModifButtonAction();
            ReDraw();
        });
        ButtonUp.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Up);
            ReDraw();
        });
        ButtonLeft.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Left);
            ReDraw();
        });
        ButtonRight.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Right);
            ReDraw();
        });
        ButtonDown.addActionListener(e -> {
            map.DirectionButtonAction(Direction.Down);
            ReDraw();
        });

        ComboBoxSelectorMap.addActionListener(e -> {
            map.ComboBoxSelectorMapAction(Objects.requireNonNull(ComboBoxSelectorMap.getSelectedItem()).toString());
            ReDraw();
        });
    }
    private void ReDraw()
    {
        Graphics2D graphics = (Graphics2D) PictureBox.getGraphics();
        graphics.clearRect(0, 0, PictureBox.getWidth(), PictureBox.getHeight());
        PictureBox.paintComponents(graphics);
        map.DrawMap(graphics);
    }

}
